const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Relatorio_andamento_atualDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const relatorio_andamento_atual = await db.relatorio_andamento_atual.create(
      {
        id: data.id || undefined,

        data_ultima_atualizacao: data.data_ultima_atualizacao || null,
        status_obra: data.status_obra || null,
        percentual_execucao_total: data.percentual_execucao_total || null,
        atividade_atual_predominante: data.atividade_atual_predominante || null,
        riscos_em_aberto: data.riscos_em_aberto || null,
        tempo_estimado_para_conclusao:
          data.tempo_estimado_para_conclusao || null,
        grau_conformidade_geral: data.grau_conformidade_geral || null,
        observacoes_finais: data.observacoes_finais || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await relatorio_andamento_atual.setObra(data.obra || null, {
      transaction,
    });

    await relatorio_andamento_atual.setUltimo_relatorio_video(
      data.ultimo_relatorio_video || null,
      {
        transaction,
      },
    );

    await relatorio_andamento_atual.setClientes(data.clientes || null, {
      transaction,
    });

    return relatorio_andamento_atual;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const relatorio_andamento_atualData = data.map((item, index) => ({
      id: item.id || undefined,

      data_ultima_atualizacao: item.data_ultima_atualizacao || null,
      status_obra: item.status_obra || null,
      percentual_execucao_total: item.percentual_execucao_total || null,
      atividade_atual_predominante: item.atividade_atual_predominante || null,
      riscos_em_aberto: item.riscos_em_aberto || null,
      tempo_estimado_para_conclusao: item.tempo_estimado_para_conclusao || null,
      grau_conformidade_geral: item.grau_conformidade_geral || null,
      observacoes_finais: item.observacoes_finais || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const relatorio_andamento_atual =
      await db.relatorio_andamento_atual.bulkCreate(
        relatorio_andamento_atualData,
        { transaction },
      );

    // For each item created, replace relation files

    return relatorio_andamento_atual;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const relatorio_andamento_atual =
      await db.relatorio_andamento_atual.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.data_ultima_atualizacao !== undefined)
      updatePayload.data_ultima_atualizacao = data.data_ultima_atualizacao;

    if (data.status_obra !== undefined)
      updatePayload.status_obra = data.status_obra;

    if (data.percentual_execucao_total !== undefined)
      updatePayload.percentual_execucao_total = data.percentual_execucao_total;

    if (data.atividade_atual_predominante !== undefined)
      updatePayload.atividade_atual_predominante =
        data.atividade_atual_predominante;

    if (data.riscos_em_aberto !== undefined)
      updatePayload.riscos_em_aberto = data.riscos_em_aberto;

    if (data.tempo_estimado_para_conclusao !== undefined)
      updatePayload.tempo_estimado_para_conclusao =
        data.tempo_estimado_para_conclusao;

    if (data.grau_conformidade_geral !== undefined)
      updatePayload.grau_conformidade_geral = data.grau_conformidade_geral;

    if (data.observacoes_finais !== undefined)
      updatePayload.observacoes_finais = data.observacoes_finais;

    updatePayload.updatedById = currentUser.id;

    await relatorio_andamento_atual.update(updatePayload, { transaction });

    if (data.obra !== undefined) {
      await relatorio_andamento_atual.setObra(
        data.obra,

        { transaction },
      );
    }

    if (data.ultimo_relatorio_video !== undefined) {
      await relatorio_andamento_atual.setUltimo_relatorio_video(
        data.ultimo_relatorio_video,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await relatorio_andamento_atual.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return relatorio_andamento_atual;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const relatorio_andamento_atual =
      await db.relatorio_andamento_atual.findAll({
        where: {
          id: {
            [Op.in]: ids,
          },
        },
        transaction,
      });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of relatorio_andamento_atual) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of relatorio_andamento_atual) {
        await record.destroy({ transaction });
      }
    });

    return relatorio_andamento_atual;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const relatorio_andamento_atual =
      await db.relatorio_andamento_atual.findByPk(id, options);

    await relatorio_andamento_atual.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await relatorio_andamento_atual.destroy({
      transaction,
    });

    return relatorio_andamento_atual;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const relatorio_andamento_atual =
      await db.relatorio_andamento_atual.findOne({ where }, { transaction });

    if (!relatorio_andamento_atual) {
      return relatorio_andamento_atual;
    }

    const output = relatorio_andamento_atual.get({ plain: true });

    output.obra = await relatorio_andamento_atual.getObra({
      transaction,
    });

    output.ultimo_relatorio_video =
      await relatorio_andamento_atual.getUltimo_relatorio_video({
        transaction,
      });

    output.clientes = await relatorio_andamento_atual.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.obras,
        as: 'obra',

        where: filter.obra
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.obra
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  nome_obra: {
                    [Op.or]: filter.obra
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.relatorios_analiticos_video,
        as: 'ultimo_relatorio_video',

        where: filter.ultimo_relatorio_video
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.ultimo_relatorio_video
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  json_analise: {
                    [Op.or]: filter.ultimo_relatorio_video
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.status_obra) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'relatorio_andamento_atual',
            'status_obra',
            filter.status_obra,
          ),
        };
      }

      if (filter.atividade_atual_predominante) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'relatorio_andamento_atual',
            'atividade_atual_predominante',
            filter.atividade_atual_predominante,
          ),
        };
      }

      if (filter.riscos_em_aberto) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'relatorio_andamento_atual',
            'riscos_em_aberto',
            filter.riscos_em_aberto,
          ),
        };
      }

      if (filter.tempo_estimado_para_conclusao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'relatorio_andamento_atual',
            'tempo_estimado_para_conclusao',
            filter.tempo_estimado_para_conclusao,
          ),
        };
      }

      if (filter.grau_conformidade_geral) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'relatorio_andamento_atual',
            'grau_conformidade_geral',
            filter.grau_conformidade_geral,
          ),
        };
      }

      if (filter.observacoes_finais) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'relatorio_andamento_atual',
            'observacoes_finais',
            filter.observacoes_finais,
          ),
        };
      }

      if (filter.data_ultima_atualizacaoRange) {
        const [start, end] = filter.data_ultima_atualizacaoRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            data_ultima_atualizacao: {
              ...where.data_ultima_atualizacao,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            data_ultima_atualizacao: {
              ...where.data_ultima_atualizacao,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.percentual_execucao_totalRange) {
        const [start, end] = filter.percentual_execucao_totalRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            percentual_execucao_total: {
              ...where.percentual_execucao_total,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            percentual_execucao_total: {
              ...where.percentual_execucao_total,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } =
        await db.relatorio_andamento_atual.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('relatorio_andamento_atual', 'status_obra', query),
        ],
      };
    }

    const records = await db.relatorio_andamento_atual.findAll({
      attributes: ['id', 'status_obra'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['status_obra', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.status_obra,
    }));
  }
};
